#include <Adafruit_NeoPixel.h>
#include <FastLED.h>
#define NUM_LEDS 96
#define LED_TYPE WS2812
#define NUMPIXELS 96
#define PIN 7
#define COLOR_ORDER GBR
#define BUTTON PD2
#define POT A0
#define MIC A1
int game = 0;
int last_val = 0;
long ts = 0;
int speed = 1;
int minLvl = 0, maxLvl = 300;

// Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
struct CRGB leds[NUMPIXELS];

void poweroff(){
	for(int i = 0; i < NUMPIXELS; i++) {
		leds[i] = CRGB(0, 0, 0);
	}
}

int convert(int i, int j, int face) {
	if(face == 0){
		int j_new = 3 - i;
		int i_new = 3 - j;
		i = i_new;
		j = j_new;
	}
  
	if(j % 2 == 0){
		return 4 * j + i;
	}else{
		return 4 * j + (3 - i);
	}
}

void snake_full(int red, int green, int blue){
	poweroff();

	for(int i = 0; i < NUMPIXELS; i++) {
		leds[i] = CRGB(red, green, blue);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}
}

void snake(int red, int green, int blue){
	poweroff();

	for(int i = 0; i < NUMPIXELS; i++) {
		if(i >= 3){
			leds[i - 3] = CRGB(0, 0, 0);
		}

		leds[i] = CRGB(red, green, blue);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}
}

void int_ext(int red, int green, int blue){
	convert_speed();
	poweroff();
	FastLED.show();
	delay(40 * speed);

	for(int k = 0; k < 5; k++){
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if((i > 0 && i < 3) && (j > 0 && j < 3)){
				  leds[k * 16 + i * 4 + j] = CRGB(red, green, blue);
				}
			}
		}
	}

	FastLED.show();
	delay(40 * speed);
	poweroff();
	FastLED.show();

	for(int k = 0; k < 5; k++){
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if(!(i > 0 && j < 3 && i < 3 && j > 0)){
				  leds[k * 16 + i * 4 + j] = CRGB(red, green, blue);
				}
			}
		}
	}

	FastLED.show();
	delay(40 * speed);
}

void diag(int red, int green, int blue) {
	convert_speed();
	poweroff();
	FastLED.show();
	delay(40 * speed);

	int pos;
	for(int l = 0; l < 4; l++){
		for(int k = 0; k < 5; k++){
			for(int i = 0; i < 4; i++){
				for(int j = 0; j < 4; j++){
					if((i - l) == j || (i + l) == j){
						pos = convert(i, j, k);
						leds[k * 16 + pos] = CRGB(red, green, blue);
					}
				}
			}
		}

		FastLED.show();
		delay(40 * speed);
		poweroff();
		FastLED.show();
		convert_speed();
	}
}

void raindrop() {
	int red = 0;
	int blue = 255;
	int green = 0;
	int pos;

	for(int i = 0; i < 4; i++){
		for(int j = 0; j < 4; j++){
			pos = convert(i, j, 1);
			leds[16 + pos] = CRGB(blue, green, red);
		}
	}

	for(int i = 0; i < 15; i++){
		convert_speed();
		for(int k = 0; k < 5; k++){
			if(k != 1){
				pos = convert((0 + i)%4, 0, k);
				leds[k*16 + pos] = CRGB(blue, green, red);

				pos = convert((1 + i)%4, 1, k);
				leds[k*16 + pos] = CRGB(blue, green, red);

				pos = convert((0 + i)%4, 2, k);
				leds[k*16 + pos] = CRGB(blue, green, red);

				pos = convert((1 + i)%4, 3, k);
				leds[k*16 + pos] = CRGB(blue, green, red);
			}else{
				for(int j = 0; j < 16; j++){
					leds[k*16 + j] = CRGB(blue, green, red);
				}
			}
		}
		FastLED.show();
		delay(40 * speed);
		poweroff();
		FastLED.show();
		convert_speed();
	}

	convert_speed();
	FastLED.show();
	delay(40 * speed);
	poweroff();
	FastLED.show();
  
}

void vortex(int red, int green, int blue){
	int pos;
	poweroff();
	FastLED.show();
   
	for(int i = 0; i < 4; i++){
		for(int k = 0; k < 5; k++){
			pos = convert(i, 0, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 1; i < 4; i++){
		for(int k = 0; k < 5; k++){
			pos = convert(3, i, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}
	
	for(int i = 3; i >= 0; i--){
		for(int k = 0; k < 5; k++){
			pos = convert(i, 3, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 2; i > 0; i--){
		for(int k = 0; k < 5; k++){
			pos = convert(0, i, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 1; i < 3 ; i++){
		for(int k = 0; k < 5; k++){
			pos = convert(i, 1, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 2; i > 0 ; i--){
		for(int k = 0; k < 5; k++){
			pos = convert(i, 2, k);
			leds[k * 16 + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}
}

void random_colour(){
	int random1;
	int random2;
	int random3;
  
	for(int i = 0; i < NUMPIXELS; i++) {
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[i] = CRGB(random1, random2, random3);
	}
  
	FastLED.show();
	delay(40 * speed);
	convert_speed();
}

void up_vortex(){
	poweroff();
	FastLED.show();
	delay(40 * speed);
 
	int pos;
	int random1, random2, random3;

	for(int i = 3; i >= 0; i--){
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		for(int k = 0; k < 5; k++){
			if(k != 1){
				for(int j = 0; j < 4; j++){
					pos = convert(i, j, k);
					leds[k * 16 + pos] = CRGB(random1, random2, random3);
				}
			}
		}

		FastLED.show();
		delay(40 * speed);  
		convert_speed();  
	}
	
	for(int i = 0; i < 4; i++){
		pos = convert(i, 0, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 1; i < 4; i++){
		pos = convert(3, i, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 3; i >= 0; i--){
		pos = convert(i, 3, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 2; i > 0; i--){
		pos = convert(0, i, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 1; i < 3 ; i++){
		pos = convert(i, 1, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}

	for(int i = 2; i > 0 ; i--){
		pos = convert(i, 2, 1);
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[16 + pos] = CRGB(random1, random2, random3);
		FastLED.show();
		delay(40 * speed);
		convert_speed();
	}
}

void arrow(int red, int green, int blue) {
	poweroff();
	FastLED.show();
	delay(100 * speed);

	int pos;
	int j = 0;
	for(int i = 3; i >= 0; i--){
		for(int k = 0; k < 5; k++){
		pos = convert(i, j, k);
		leds[16 * k + pos] = CRGB(red, green, blue);
		}

		FastLED.show();
		delay(40 * speed);
		convert_speed();
		j++;
	}

	int pos1, pos2;
	int i_1, i_2, j_1, j_2;
	i_1 = 0;
	j_2 = 3;
	j_1 = 2;
	i_2 = 1;
	for(int l = 0; l < 3; l++){
		for(int k = 0; k < 5; k++){
			pos1 = convert(i_1, j_1, k);
			pos2 = convert(i_2, j_2, k);
			leds[16 * k + pos1] = CRGB(red, green, blue);
			leds[16 * k + pos2] = CRGB(red, green, blue);
		}

		convert_speed();
		FastLED.show();
		delay(40 * speed);
		j_1--;
		i_2++;
	}
}

void random_star(){
	convert_speed();
	poweroff();
	FastLED.show();
	delay(40 * speed);
  
	int pos;
	int random1, random2, random3;
	for(int i = 0; i < 50; i++){
		pos = rand() % 96;
		random1 = rand() % 50 + 1;
		random2 = rand() % 100 + 1;
		random3 = rand() % 250 + 1;
		leds[pos] = CRGB(random1, random2, random3);
	}

	convert_speed();
	FastLED.show();
	delay(40 * speed);
   
}

void X_O(int red, int green, int blue){
	convert_speed();
	poweroff();
	FastLED.show();
	delay(40 * speed);
  
	int pos;
	for(int k = 0; k < 5; k++){
		convert_speed();
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if((i == j) || (i + j) == 3){
					pos = convert(i, j, k);
					leds[16 * k + pos] = CRGB(red, green, blue);
				}
			}
		}
	}

	FastLED.show();
	delay(40 * speed);

	poweroff();
	FastLED.show();
	delay(40 * speed);

	for(int k = 0; k < 5; k++){
		convert_speed();
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if((i == 0 || i == 3) || (j == 0 || j == 3)){
					pos = convert(i, j, k);
					leds[16 * k + pos] = CRGB(red, green, blue);
				}
			}
		}
	}
  
}

ISR(PCINT2_vect)
{
	// Debounce
	if (millis() - ts > 300) {
		ts = millis();
		game = (game + 1) % 12;
	}
}

void setup() {
	Serial.begin(9600);
	LEDS.addLeds<LED_TYPE, PIN, COLOR_ORDER>(leds, NUMPIXELS);
	FastLED.setBrightness(10);

	pinMode(A0, INPUT);
	pinMode(MIC, INPUT);

	// Button setup
	DDRD &= ~(1 << BUTTON);
	PORTD |= (1 << BUTTON);

	// Interrupt setup for button
	PCICR |= (1 << PCIE2);
	PCMSK2 |= (1 << PCINT18);

	sei();
}

void convert_speed() {
	int speed_read = analogRead(POT);
	int val = map(speed_read, 0, 1023, 0, 100);
	speed = (100 / (val + 1));
}

void turn_on_lines(int lines, int red, int green, int blue){
	int pos;
	for(int k = 0; k < 5; k++){
		if(k != 1){
			for(int i = 3; i >= lines; i--){
				for(int j = 0; j < 4; j++){
					pos = convert(i, j, k);
					leds[16 * k + pos] = CRGB(red, green, blue);
				}
			}
		}
	}

	FastLED.show();
	delay(100);
}

void turn_on_diag(int lines, int red, int green, int blue) {
	int pos;
	for(int l = 0; l <= lines; l++){
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if((i - l) == j || (i + l) == j){
					pos = convert(i, j, 1);
					leds[16 + pos] = CRGB(red, green, blue);
				}
			}
		}
	}
	FastLED.show();
	delay(100);
}

void fade_color()
{
	int red = 0;
	int blue = 0;
	int green = 0;
	while(game == 11){

		int val = analogRead(POT);

		if(val < 341){
			val = (val * 3) / 4;
			red = 256 - val;
			green = val;
			blue = 1;
		}else if(val < 682){
			val = ((val - 341) * 3) / 4;
			red = 1;
			green = 256 - val;
			blue = val;
		}else{
			val = ((val - 683) * 3) / 4;
			red = val;
			green = 1;
			blue = 256 - val;
		}

		for(int i = 0; i < NUMPIXELS; i++) {
			leds[i] = CRGB(red, green, blue);
		}

		FastLED.show();
	}
}

void disco_1(){
	int red, green, blue, sound;
	while(game == 10){
		red = rand() % 50 + 1;
		green = rand() % 100 + 1;
		blue = rand() % 250 + 1;
		sound = analogRead(MIC);

		poweroff();
		FastLED.show();
		delay(50);

		if(sound < 20){
			poweroff();
			FastLED.show();
		}else if(sound < 45){
			turn_on_lines(3, red, green, blue);
			turn_on_diag(0, red, green, blue);
		}else if (sound < 90){
			turn_on_lines(2, red, green, blue);
			turn_on_diag(1, red, green, blue);
		}else if (sound < 135){
			turn_on_lines(1, red, green, blue);
			turn_on_diag(2, red, green, blue);
		}else{
			turn_on_lines(0, red, green, blue);
			turn_on_diag(3, red, green, blue);
		}

		poweroff();
		FastLED.show();
		delay(50);
  	}	
}

void loop() {
  	// put your main code here, to run repeatedly:
	int random1 = rand() % 50 + 1;
	int random2 = rand() % 100 + 1;
	int random3 = rand() % 250 + 1;

	convert_speed();
 
	switch(game){
		case 0:
			snake_full(random1, random2, random3);
			break;
		case 1:
			snake(random1, random2, random3);
			break;
		case 2:
			int_ext(random1, random2, random3);
			break;
		case 3:
			diag(random1, random2, random3);
			break;
		case 4:
			raindrop();
			break;
		case 5:
			vortex(random1, random2, random3);
			break;
		case 6:
			arrow(random1, random2, random3);
			break;
		case 7:
			random_star();
			break;
		case 8:
			X_O(random1, random2, random3);
			break;
		case 9:
			up_vortex();
			break;
		case 10:
			disco_1();
			break;
		case 11:
			fade_color();
			break;
	}

	FastLED.show();
	delay(200);
}
